var fis96000_conferencia_fiscal_Controller = function(ZHPromise, General, templateManager, ScreenService, ZhFilterPreferences, Messages_fiscal)
{
    var self = this; // Variável para guardar o escopo atual nas funções.
    var windowCurrentlyOpen = false; // Variável de controle para o armazenamento da widget atualmente aberta.
    var PERIODO = false; // Armazena o período do filtro atual. Serve para se transferir os valores para o próximo filtro
    var CDTIPOOPER      = false; // Armazena o tipo de operação do filtro atual. Serve para se transferir os valores para o próximo filtro
    var IDENTRSAIDOP_AR = false;
    var APPLIEDFILTER = false; // Armazena o filtro aplicado

    /*
     * Função que verifica o clique em uma das opções disponíveis na widget
     * principal. Determina se um swipe será aberto ou não, dependendo da
     * opção selecionada.
     */
    this.mainWidgetAfterMoveRow = function(widget) {
        // Guarda o nome da widget relacionada à opção clicada, se houver.
        var windowToOpen = widget.currentRow.WINDOW;
        // Guarda a propriedade "ENABLED" da opção selecionada.
        var windowEnabled = widget.currentRow.ENABLED;

        // Verifica se há uma widget associada (não for um submenu) e se esta está habilitada (a tela estiver disponível para ser utilizada).
        if (windowToOpen && windowEnabled) {
            // Verifica se já há uma widget aberta e se esta é diferente da selecionada.
            if (windowCurrentlyOpen && windowCurrentlyOpen != windowToOpen) {
                // Fecha o swipe com a widget já aberta.
                self.closeSwipe(templateManager.container.getWidget(windowCurrentlyOpen)).then(function() {
                    // Abre o swipe na widget selecionada.
                    ScreenService.openSwipe(templateManager.container.getWidget(windowToOpen));
                });
            } else { // Senão, abre o swipe na opção selecionada.
                // Abre o swipe na widget selecionada.
                ScreenService.openSwipe(templateManager.container.getWidget(windowToOpen));
            }
            // Altera a variável de controle da widget atualmente aberta.
            windowCurrentlyOpen = windowToOpen;
        } else // Senão, verifica se não há a propriedade "ENABLED" na opção selecionada, indicando que é um submenu.
            if (windowEnabled !== false) {
                // Altera o estado aberto/fechado do submenu.
                widget.currentRow._opened = !widget.currentRow._opened;
            }
    };


    /* Função para sair de uma "tela" e retornar à widget principal. */
    this.closeSwipe = function(widget) {
        // Prepara uma promise para esta função.
        var deferred = ZHPromise.defer();
        var mainWidget = templateManager.container.getWidget("mainWidget");

        // Desativa a widget atualmente aberta.
        widget.deactivate();

        // Limpa a variável que indica qual a widget atualmente aberta.
        windowCurrentlyOpen = false;

        // Fecha o swipe.
        ScreenService.goBack().then(function() {
            // Ativa a widget principal.
            mainWidget.activate();
            // Finaliza a promise retornada.
            deferred.resolve();
        });
        // Retorna a promise preparada.
        return deferred.promise;
    };

    /*Abre o filtro*/
    this.openFilter = function( args, nmWidget ) {
        //todo fazer genérica
        var filteredWidget = templateManager.container.getWidget(nmWidget);
        var rowsToSet = filteredWidget.appliedFilter || {FILTER_ROW:{}};
        rowsToSet.FILTER_ROW.IDENTRSAIDOP = null;

        ZhFilterPreferences.openFilterWidget(filteredWidget, rowsToSet.FILTER_ROW);
    };

    /*Ajusta Campos após filtro aplicado - apenas para Pendências de Fechamento*/
    this.filter = function( args, widgetIndex ) {
        var dataSourceFilter = args.owner.dataSourceFilter;
        var filterPende = []; //nf_pendente_aprovacao_transmissao
        var filterCupom = []; //fechamento_cupom_pendente
        var filterIncid = []; //conferencia_nf_sem_incidencia
        var i;

        //Percorre o filtro principal a procura de campos correspondentes
        for( i = 0; i < dataSourceFilter.length; ++i ) {
            //Adiciona somente os filtros de interesse para a query de coferencia de cupom fechado
            switch( dataSourceFilter[ i ].name ) {
                //Filtros comuns para todos
                case "PERIODO":

                    filterPende.push( {"name": "DTINIPERIODO", "operator": "=", "value": dataSourceFilter[ i ].value[0]} );
                    filterPende.push( {"name": "DTFIMPERIODO", "operator": "=", "value": dataSourceFilter[ i ].value[1]} );

                    filterCupom.push( {"name": "DTINIPERIODO", "operator": "=", "value": dataSourceFilter[ i ].value[0]} );
                    filterCupom.push( {"name": "DTFIMPERIODO", "operator": "=", "value": dataSourceFilter[ i ].value[1]} );

                    filterIncid.push( {"name": "DTINIPERIODO", "operator": "=", "value": dataSourceFilter[ i ].value[0]} );
                    filterIncid.push( {"name": "DTFIMPERIODO", "operator": "=", "value": dataSourceFilter[ i ].value[1]} );

                    break;
                case "CDEMPRESA":
                case "CDIMPOSTONFE":
                case "CDINSCESTA":
                case "CDINSCMUNI":
                    filterPende.push( dataSourceFilter[ i ] );
                    filterCupom.push( dataSourceFilter[ i ] );
                    filterIncid.push( dataSourceFilter[ i ] );
                    break;
                //Filtros exlusivos do nf_pendente_aprovacao_transmissao
                case "CDMODDOCFISC":
                //case "CDTIPOOPER":
                    filterPende.push( dataSourceFilter[ i ] );
                    break;
                case "IDENTRSAIDOP":
                    filterPende.push( dataSourceFilter[ i ] );
                    filterIncid.push( dataSourceFilter[ i ] );
                    break;
            }
        }

        //*Aquisição de widgets
        var widgetOrigem = args.owner.getParent().widgets[ widgetIndex ];
        var widgetPende = templateManager.container.getWidget('nf_pendente_aprovacao_transmissao'); //nf_pendente_aprovacao_transmissao
        var widgetCupom = templateManager.container.getWidget('fechamento_cupom_pendente'); //fechamento_cupom_pendente
        var widgetIncid = templateManager.container.getWidget('conferencia_nf_sem_incidencia'); //conferencia_nf_sem_incidencia

        widgetCupom.appliedFilter = widgetOrigem.appliedFilter;
        widgetPende.appliedFilter = widgetOrigem.appliedFilter;
        widgetIncid.appliedFilter = widgetOrigem.appliedFilter;

        //Atualiza e ajusta os demais filtros de acorda com a widget de oprigem
        switch( widgetIndex ) {
            case 0: //nf_pendente_aprovacao_transmissao
                //Cupom
                widgetCupom.appliedFilter = widgetOrigem.appliedFilter;
                widgetCupom.dataSourceFilter = filterCupom;
                //widgetCupom.reload();

                widgetCupom.getField( "CDINSCESTA" ).readOnly = !widgetOrigem.appliedFilter.FILTER_ROW.CDINSCESTA;
                widgetCupom.getField( "CDINSCESTA" ).dataSourceFilter =
                    [ { name: "CDEMPRESA", operator: "=", value: widgetOrigem.appliedFilter.FILTER_ROW.CDEMPRESA } ];
                widgetCupom.getField( "CDINSCESTA" ).reload();

                widgetCupom.getField( "CDINSCMUNI" ).readOnly = !widgetOrigem.appliedFilter.FILTER_ROW.CDINSCMUNI;
                widgetCupom.getField( "CDINSCMUNI" ).dataSourceFilter =
                    [ { name: "CDEMPRESA", operator: "=", value: widgetOrigem.appliedFilter.FILTER_ROW.CDEMPRESA } ];
                widgetCupom.getField( "CDINSCMUNI" ).reload();
                //Incid
                widgetIncid.appliedFilter = widgetOrigem.appliedFilter;
                widgetIncid.dataSourceFilter = filterIncid;
                //widgetIncid.reload();

                widgetIncid.getField( "CDINSCESTA" ).readOnly = false; //!widgetOrigem.appliedFilter.FILTER_ROW.CDINSCESTA;
                widgetIncid.getField( "CDINSCESTA" ).dataSourceFilter =
                    [ { name: "CDEMPRESA", operator: "=", value: widgetOrigem.appliedFilter.FILTER_ROW.CDEMPRESA } ];
                widgetIncid.getField( "CDINSCESTA" ).reload();

                widgetIncid.getField( "CDINSCMUNI" ).readOnly = false; //!widgetOrigem.appliedFilter.FILTER_ROW.CDINSCMUNI;
                widgetIncid.getField( "CDINSCMUNI" ).dataSourceFilter =
                    [ { name: "CDEMPRESA", operator: "=", value: widgetOrigem.appliedFilter.FILTER_ROW.CDEMPRESA } ];
                widgetIncid.getField( "CDINSCMUNI" ).reload();

                widgetOrigem.dataSourceFilter = filterPende;
                widgetOrigem.reload();
                break;
            case 1: //fechamento_cupom_pendente
                //Pende
                widgetPende.appliedFilter = widgetOrigem.appliedFilter;
                widgetPende.dataSourceFilter = filterPende;
                //widgetPende.reload();

                widgetPende.getField( "CDINSCESTA" ).readOnly = !widgetOrigem.appliedFilter.FILTER_ROW.CDINSCESTA;
                widgetPende.getField( "CDINSCESTA" ).dataSourceFilter =
                    [ { name: "CDEMPRESA", operator: "=", value: widgetOrigem.appliedFilter.FILTER_ROW.CDEMPRESA } ];
                widgetPende.getField( "CDINSCESTA" ).reload();

                widgetPende.getField( "CDINSCMUNI" ).readOnly = !widgetOrigem.appliedFilter.FILTER_ROW.CDINSCMUNI;
                widgetPende.getField( "CDINSCMUNI" ).dataSourceFilter =
                    [ { name: "CDEMPRESA", operator: "=", value: widgetOrigem.appliedFilter.FILTER_ROW.CDEMPRESA } ];
                widgetPende.getField( "CDINSCMUNI" ).reload();
                //Incid
                widgetIncid.appliedFilter = widgetOrigem.appliedFilter;
                widgetIncid.dataSourceFilter = filterIncid;
                //widgetIncid.reload();

                widgetIncid.getField( "CDINSCESTA" ).readOnly = false; //!widgetOrigem.appliedFilter.FILTER_ROW.CDINSCESTA;
                widgetIncid.getField( "CDINSCESTA" ).dataSourceFilter =
                    [ { name: "CDEMPRESA", operator: "=", value: widgetOrigem.appliedFilter.FILTER_ROW.CDEMPRESA } ];
                widgetIncid.getField( "CDINSCESTA" ).reload();

                widgetIncid.getField( "CDINSCMUNI" ).readOnly = false; //!widgetOrigem.appliedFilter.FILTER_ROW.CDINSCMUNI;
                widgetIncid.getField( "CDINSCMUNI" ).dataSourceFilter =
                    [ { name: "CDEMPRESA", operator: "=", value: widgetOrigem.appliedFilter.FILTER_ROW.CDEMPRESA } ];
                widgetIncid.getField( "CDINSCMUNI" ).reload();

                widgetOrigem.dataSourceFilter = filterCupom;
                widgetOrigem.reload();
                break;
            case 2: //conferencia_nf_sem_incidencia
                //Cupom
                widgetCupom.appliedFilter = widgetOrigem.appliedFilter;
                widgetCupom.dataSourceFilter = filterCupom;
                //widgetCupom.reload();

                widgetCupom.getField( "CDINSCESTA" ).readOnly = !widgetOrigem.appliedFilter.FILTER_ROW.CDINSCESTA;
                widgetCupom.getField( "CDINSCESTA" ).dataSourceFilter =
                    [ { name: "CDEMPRESA", operator: "=", value: widgetOrigem.appliedFilter.FILTER_ROW.CDEMPRESA } ];
                widgetCupom.getField( "CDINSCESTA" ).reload();

                widgetCupom.getField( "CDINSCMUNI" ).readOnly = !widgetOrigem.appliedFilter.FILTER_ROW.CDINSCMUNI;
                widgetCupom.getField( "CDINSCMUNI" ).dataSourceFilter =
                    [ { name: "CDEMPRESA", operator: "=", value: widgetOrigem.appliedFilter.FILTER_ROW.CDEMPRESA } ];
                widgetCupom.getField( "CDINSCMUNI" ).reload();
                //Pende
                widgetPende.appliedFilter = widgetOrigem.appliedFilter;
                widgetPende.dataSourceFilter = filterPende;
                //widgetPende.reload();

                widgetPende.getField( "CDINSCESTA" ).readOnly = !widgetOrigem.appliedFilter.FILTER_ROW.CDINSCESTA;
                widgetPende.getField( "CDINSCESTA" ).dataSourceFilter =
                    [ { name: "CDEMPRESA", operator: "=", value: widgetOrigem.appliedFilter.FILTER_ROW.CDEMPRESA } ];
                widgetPende.getField( "CDINSCESTA" ).reload();

                widgetPende.getField( "CDINSCMUNI" ).readOnly = !widgetOrigem.appliedFilter.FILTER_ROW.CDINSCMUNI;
                widgetPende.getField( "CDINSCMUNI" ).dataSourceFilter =
                    [ { name: "CDEMPRESA", operator: "=", value: widgetOrigem.appliedFilter.FILTER_ROW.CDEMPRESA } ];
                widgetPende.getField( "CDINSCMUNI" ).reload();

                widgetOrigem.dataSourceFilter = filterIncid;
                widgetOrigem.reload();
                break;
        }

        //Remove o CDTIPOOPER para evitar conflitos no filtro
        /*for( i = dataSourceFilter.length - 1; i >= 0; i-- )
          if ( dataSourceFilter[i].name == 'CDTIPOOPER')
            dataSourceFilter.splice( i, 1 );*/
        //args.e.preference.FILTER_ROW.CDTIPOOPER = [];

        args.e.preference.FILTER_ROW.CDTIPOOPER      = CDTIPOOPER; //Recupera o Valor do Filtro
        args.e.preference.FILTER_ROW.IDENTRSAIDOP_AR = IDENTRSAIDOP_AR; //Recupera o Valor do Filtro
        widgetOrigem.reload();
    };

    /*Trata o 'IN' para o tipo operação vs entr/saida (não relacio0nado ao campo Entrada / Saída IDENTRSAIDOP )*/
    this.ajustaCdtipooper = function( args ) {
        var Filter           = args.e.preference.FILTER_ROW;
        var TipooperEntrsaid = [];

        CDTIPOOPER      = Filter.CDTIPOOPER;      //Salva o filtro para os filtros da demais widgets
        IDENTRSAIDOP_AR = Filter.IDENTRSAIDOP_AR; //Salva o filtro para os filtros da demais widgets

        if( Filter.hasOwnProperty( 'CDTIPOOPER' ) ) { //Verifica a existência deste campo
            if( Filter.CDTIPOOPER && Filter.CDTIPOOPER.length != 0 ) { //Verifica se houve alhguma opção selecionado (este campo não é required)
                for( var i = 0; i < Filter.CDTIPOOPER.length; ++i) { //Monta o array concatenado
                    TipooperEntrsaid[i] = Filter.IDENTRSAIDOP_AR[i] + Filter.CDTIPOOPER[i];
                }
                Filter.CDTIPOOPER = TipooperEntrsaid;
            }
        }
    };

    /*Adiciona as datas de inio e fim a partir do campo PERIODO e o remove*/
    this.manipulaFilter = function( args ) {
        var Filter           = args.e.preference.FILTER_ROW;
        var DataSourceFilter = [];

        //Trata o filtro de período de datas
        if( Filter.hasOwnProperty( 'PERIODO' ) ) {
            /*args.owner.dataSourceFilter[1] = {"name": "DTINIPERIODO", "operator": "=", "value": Filter.PERIODO.start};
            args.owner.dataSourceFilter[2] = {"name": "DTFIMPERIODO", "operator": "=", "value": Filter.PERIODO.end  };*/
            DataSourceFilter.push( {"name": "DTINIPERIODO", "operator": "=", "value": Filter.PERIODO.start} );
            DataSourceFilter.push( {"name": "DTFIMPERIODO", "operator": "=", "value": Filter.PERIODO.end  } );
            PERIODO = Filter.PERIODO;
            delete Filter.PERIODO;
        }

        //Trata o 'IN' para o tipo operação vs entr/saida (não relacio0nado ao campo Entrada / Saída IDENTRSAIDOP )
        var TipooperEntrsaid = [];
        if( Filter.hasOwnProperty( 'CDTIPOOPER' ) ) { //Verifica a existência deste campo
            if( Filter.CDTIPOOPER.length == 0 ) { //Verifica se houve alguma opção selecionado (este campo não é required)
                CDTIPOOPER      = false;
                IDENTRSAIDOP_AR = false;
            } else {
                for( var i = 0; i < Filter.CDTIPOOPER.length; ++i) { //Monta o array concatenado
                    TipooperEntrsaid[i] = Filter.IDENTRSAIDOP_AR[i] + Filter.CDTIPOOPER[i];
                }
                CDTIPOOPER      = Filter.CDTIPOOPER;      //Salva o filtro para os filtros da demais widgets
                IDENTRSAIDOP_AR = Filter.IDENTRSAIDOP_AR; //Salva o filtro para os filtros da demais widgets
                DataSourceFilter.push( {"name": "TIPOOPER_ENTRSAID", "operator": "IN", "value": TipooperEntrsaid} );
            }
            delete Filter.CDTIPOOPER;
            delete Filter.IDENTRSAIDOP_AR;
            delete Filter.NMTIPOOPER;
        }

        args.owner.dataSourceFilter = DataSourceFilter;

    };

    /*Realiza o filtro da tela/relatório nf_periodo_mapa*/
    this.filtra_nf_periodo_mapa = function( args, widgetIndex ) {
        APPLIEDFILTER = args.owner.appliedFilter;

        //Aquisição de widgets nf_periodo_mapa_nf_fora_periodo e nf_periodo_mapa_nf_sem_mapa
        var widgetOrigem  = args.owner.getParent().widgets[ widgetIndex              ];
        var widgetDestino = args.owner.getParent().widgets[ widgetIndex == 0 ? 1 : 0 ];

        widgetDestino.appliedFilter = widgetOrigem.appliedFilter;
        if( PERIODO ) { //Adiciona o período informado no filtro anterior para este vir preechido no filtro seguinte.
            widgetDestino.appliedFilter.FILTER_ROW.PERIODO = PERIODO;
        }
        if( CDTIPOOPER ) {
            widgetDestino.appliedFilter.FILTER_ROW.CDTIPOOPER = CDTIPOOPER;
        }
        if( IDENTRSAIDOP_AR ) {
            widgetDestino.appliedFilter.FILTER_ROW.IDENTRSAIDOP_AR = IDENTRSAIDOP_AR;
        }
        widgetDestino.dataSourceFilter = args.owner.dataSourceFilter;
        widgetDestino.reload();

        //widgetDestino.getField( "CDINSCESTA" ).readOnly = false;
        widgetDestino.getField( "CDINSCESTA" ).readOnly = !widgetOrigem.appliedFilter.FILTER_ROW.CDINSCESTA;
        widgetDestino.getField( "CDINSCESTA" ).dataSourceFilter =
            [ { name: "CDEMPRESA", operator: "=", value: widgetOrigem.appliedFilter.FILTER_ROW.CDEMPRESA } ];
        widgetDestino.getField( "CDINSCESTA" ).reload();

        //widgetDestino.getField( "CDINSCMUNI" ).readOnly = false;
        widgetDestino.getField( "CDINSCMUNI" ).readOnly = !widgetOrigem.appliedFilter.FILTER_ROW.CDINSCMUNI;
        widgetDestino.getField( "CDINSCMUNI" ).dataSourceFilter =
            [ { name: "CDEMPRESA", operator: "=", value: widgetOrigem.appliedFilter.FILTER_ROW.CDEMPRESA } ];
        widgetDestino.getField( "CDINSCMUNI" ).reload();

    };

    /*Controla os campos de inscrição estadual e municipal de acordo com a empresa e o imposto*/
    this.controlaCampoInscricao = function( args ) {
        var cdEmpresa = args.owner.field.widget.currentRow.CDEMPRESA    || "";
        var cdImposto = args.owner.field.widget.currentRow.CDIMPOSTONFE || "";

        var widget = args.owner.field.widget;

        var sgImposto  = args.owner.field.widget.getField( 'SGIMPOSTONFE' );

        var ativa = function( widget, nmField ) {
            var field = widget.getField( nmField );
            field.readOnly = false;
            field.validations = {required: true};
        };
        var desativa = function( widget, nmField ) {
            var field = widget.getField( nmField );
            field.clearValue();
            field.readOnly = true;
            field.validations = {};
            widget.currentRow[ nmField ] = "";
        };
        var setFilter = function( nmField, cdEmpresa ) {
            var field = widget.getField( nmField );
            if( cdEmpresa ) {
                field.dataSourceFilter = [ { name: "CDEMPRESA", operator: "=", value: cdEmpresa } ];
                field.reload();
            } else {
                field.clearValue();
            }
        };

        //Verifica se ambos campos estão preenchido para prosseguir
        if( cdEmpresa && cdImposto ) {
            //Os campos IDORGARRECADNFE e IDFORMAPURNFE devem estar preenchidos
            var tpInscr = widget.currentRow.IDORGARRECADNFE || "";
            var idFApur = widget.currentRow.IDFORMAPURNFE   || "";
            if( !idFApur || !tpInscr ) {
                var imp = widget.currentRow.CDIMPOSTONFE + " - " + widget.currentRow.SGIMPOSTONFE;
                var msg = Messages_fiscal.IMPOSTO_REL_SEM_PARAM.replace( "#1", imp );
                ScreenService.showMessage( msg );
                sgImposto.clearValue();
            }
            //Seta o campo correspondente ao tipo de imposto
            switch ( tpInscr ) {
                case 'M': //Inscrição Municipal
                    ativa( widget, 'CDINSCMUNI' );
                    desativa( widget, 'CDINSCESTA' );
                    setFilter( 'CDINSCMUNI', cdEmpresa );
                    break;
                case 'E': //Inscrição Estadual
                    ativa( widget, 'CDINSCESTA' );
                    desativa( widget, 'CDINSCMUNI' );
                    setFilter( 'CDINSCESTA', cdEmpresa );
                    break;
                default:
                    desativa( widget, 'CDINSCESTA' );
                    desativa( widget, 'CDINSCMUNI' );
            }
        } else {
            desativa( widget, 'CDINSCESTA' );
            desativa( widget, 'CDINSCMUNI' );
        }
    };
    this.controlaCampoInscricao2 = function( args ) {
        var cdEmpresa = args.owner.field.widget.currentRow.CDEMPRESA || "";
        var widget = args.owner.field.widget;

        var setFilter = function( nmField, cdEmpresa ) {
            var field = widget.getField( nmField );
            if( cdEmpresa ) {
                field.dataSourceFilter = [ { name: "CDEMPRESA", operator: "=", value: cdEmpresa } ];
                field.reload();
            } else {
                field.clearValue();
            }
        };

        //Seta o campo correspondente ao tipo de imposto
        setFilter( 'CDINSCMUNI', cdEmpresa );
        setFilter( 'CDINSCESTA', cdEmpresa );
    };


    this.entradaSaida = function(args){
        var entsaid  = args.row.IDENTRSAIDOP;
        var cdtipooper  = args.owner.getParent().getParent().getField('CDTIPOOPER');

        if (entsaid != "A"){
             cdtipooper.dataSourceFilter = [
                {
                    "name": "IDENTRSAIDOP",
                    "operator": "=",
                    "value": entsaid
                }
            ];
        }else {
             cdtipooper.dataSourceFilter = [];
        }

        cdtipooper.reload();
    };

    /**
    * Verifica se a datra inicial é maior que a data final
    *
    * @param {object} widget da widget de
    * Documentos Fiscais
    */
    this.validaData = function (currentRow) {
		var dataInicial = currentRow.DTINIPERIODO ? moment(currentRow.DTINIPERIODO, 'DD/MM/YYYY').format("DD/MM/YYYY") : null;
		var dataFinal = currentRow.DTFIMPERIODO ? moment(currentRow.DTFIMPERIODO, 'DD/MM/YYYY').format("DD/MM/YYYY") : null;
		var mensagem = "A data inicial deve ser menor ou igual a data final.";

		if (dataInicial && dataFinal && dataFinal < dataInicial) {
			ScreenService.showMessage(mensagem);
			return false;
		}
		return true;
	};
	/**
    * Realisa validação dos fiels da widget
    *
    * @param {object, object, object} widget da widget de
    * Documentos Fiscais
    */
    this.validaCampos = function(currentRow, widget, args) {
		currentRow.REPORT_CODE = 'FIS96035';
		currentRow.DTINICIO = currentRow.PERIODO.start;
		currentRow.DTFINAL = currentRow.PERIODO.end;
		if (this.validaData(currentRow)) {
			if(widget.isValid()) {
            	General.openReportPopup(widget, this.abreRelatorio, [currentRow, args]);
				//this.abreRelatorio(currentRow, args);
			}
		}
	};
     /**
    * Gera o relatorio em PDF
    *
    * @param {object, object widget da widget de
    * Documentos Fiscais
    */
    this.abreRelatorio = function(currentRow, args) {
    	var relatorio  = currentRow.REPORT_CODE;
    	General.openReport('fis_relatorios#/relatorio_apuracao_imposto', relatorio, args.row);
    }.bind(this);

    /*Ajusta a visibilidade dos campos de inscrição estadual e municipal*/
    /*Fora de uso WidgetOnEnter*/
    /*this.ajsutaInscReadOnly = function( args ) {
        if( APPLIEDFILTER ) {
            args.owner.appliedFilter = APPLIEDFILTER;
            if( PERIODO ){ //Adiciona o período informado no filtro anterior para este vir preechido no filtro seguinte.
                args.owner.appliedFilter.FILTER_ROW.PERIODO = PERIODO;
            }

            args.owner.getField( "CDINSCESTA" ).readOnly = !args.owner.appliedFilter.FILTER_ROW.CDINSCESTA;
            args.owner.getField( "CDINSCESTA" ).dataSourceFilter =
                [ { name: "CDEMPRESA", operator: "=", value: args.owner.appliedFilter.FILTER_ROW.CDEMPRESA } ];
            args.owner.getField( "CDINSCESTA" ).reload();

            args.owner.getField( "CDINSCMUNI" ).readOnly = !args.owner.appliedFilter.FILTER_ROW.CDINSCMUNI;
            args.owner.getField( "CDINSCMUNI" ).dataSourceFilter =
                [ { name: "CDINSCMUNI", operator: "=", value: args.owner.appliedFilter.FILTER_ROW.CDEMPRESA } ];
            args.owner.getField( "CDINSCMUNI" ).reload();
        }
    };*/
};

/* global Configuration */
Configuration(function (ContextRegister)
{
    ContextRegister.register('fis96000_conferencia_fiscal_Controller', fis96000_conferencia_fiscal_Controller);
});




function fis96000_conferencia_fiscal_relatorios_Controller(General, ScreenService, templateManager, localStorageEngine) {
    var self = this;

     /**
    *  Torna visível os campos para o relatório selecionado
    *
    * @param {object} widget widget de
    * Documentos Fiscais
    */
    this.abreCamposRelatorio = function(widget){
        this.limpaCampos(widget);
        var campos = [];
        var relatorio = widget.currentRow.REPORT_CODE;
        this.layoutRelatorio(relatorio, widget, campos);
    };
     /**
    *  Recarrega o popup para cada campo select simples
    *
    * @param {object} field da widget de
    * Documentos Fiscais
    */

    this.reloadData = function(campo){
        campo.reload();
    };
     /**
    *  Reseta os campo de cada relatorio apos selecionar novo relatório
    *
    * @param {object} widget da widget de
    * Documentos Fiscais
    */
    this.limpaCamposPoEmpresa = function(widget){
         widget.fields.forEach(function(field){
         if(field.name != "REPORT_NAME"){
             if(field.name != "SGIMPOSTONFE"){
                 if(field.isVisible){
                    this.clearCampo(field);
                 }
             }
         }
        }.bind(this));
        //this.setFiltroCampoDTINIPERIODO(widget);
    };

    this.limpaCampos = function(widget){
        widget.fields.forEach(function(field){
         if(field.name != "REPORT_NAME"){
            this.clearCampo(field);
         }
        }.bind(this));
    };
      /**
    *  Limpa os campo para qualquer tipo de field
    *
    * @param {object} widget da widget de
    * Documentos Fiscais
    */
    this.clearCampo = function(field) {
			field.widget.currentRow[field.name] = "";
			field.formattedValue = "";
			field.currentDate = moment().startOf('month').startOf('day');
			if (field.change) {
				field.change();
			}
	};
      /**
    * Configura o campo obrigatorio por tipo de relatório
    *
    * @param {object, string, string} widget da widget de
    * Documentos Fiscais
    */
    this.configCampos = function(relatorio, field, camposNaoObrigat, camposReadOnly){
        var isRequired = camposNaoObrigat.includes(field.name);
        var readOnly =  camposReadOnly.includes(field.name);
        //obrigatorio
        if(!isRequired){
            field.validations = {"required": true};
        }
        //apenas leitura
        field.readOnly = readOnly;

    };
      /**
    *  Seta campo de acordo com a regras para cada relatório
    *
    * @param {object, object, array, int} widget da widget de
    * Documentos Fiscais
    */
    this.setaCampos = function(campos, widget, camposNaoObrigat = [], camposReadOnly = []){
        var relatorio = widget.currentRow.REPORT_CODE;
        if(relatorio){
         campos.forEach(function(campo) {
            widget.fields.forEach(function(field) {
                if(campo == field.name){
                    field.isVisible = true;
                    this.configCampos(relatorio, field, camposNaoObrigat, camposReadOnly);
                    //this.layoutRelatorio(widget);
                }
            }.bind(this));
        }.bind(this));
     }else{
         this.limpaTela(widget);
     }
    };

      /**
    * Retira dos os fields se nenhum relatório for selecionado
    *
    * @param {object} widget da widget de
    * Documentos Fiscais
    */
    this.limpaTela = function(widget){
        widget.fields.forEach(function(field) {
            if(field.name != "REPORT_NAME"){
                field.isVisible = false;
                field.validations = {};
                field.readOnly = false;
            }
        });
    };
      /**
    * Abre o popup para selecionar o tipo de apuração
    *
    * @param {null}
    */
    this.abriFiltro = function(){
        var fltro = templateManager.container.getWidget("tipoRelatorioApuracao");
        fltro.isVisible = true;
        ScreenService.openPopup(fltro);
    };

      /**
    * Trata o formato da data retirando a parte de horas
    *
    * @param {object} widget da widget de
    * Documentos Fiscais
    */
    this.formataDataInicio = function(widget){
     	var data = widget.currentRow.DTINICIO;
     	var corte = data.substring(0, 10);
     	widget.currentRow.DTINICIO = corte;
    };
       /**
    * Trata o formato da data retirando a parte de horas
    *
    * @param {object} widget da widget de
    * Documentos Fiscais
    */
    this.formataDataFinal = function(widget){
     	var data = widget.currentRow.DTFINAL;
     	var corte = data.substring(0, 10);
     	widget.currentRow.DTFINAL = corte;
     };
    /**
    * Verifica se a datra inicial é maior que a data final
    *
    * @param {object} widget da widget de
    * Documentos Fiscais
    */
    this.validaData = function (currentRow) {
		var dataInicial = currentRow.DTINIPERIODO ? moment(currentRow.DTINIPERIODO, 'DD/MM/YYYY').format("DD/MM/YYYY") : null;
		var dataFinal = currentRow.DTFIMPERIODO ? moment(currentRow.DTFIMPERIODO, 'DD/MM/YYYY').format("DD/MM/YYYY") : null;
		var mensagem = "A data inicial deve ser menor ou igual a data final.";

		if (dataInicial && dataFinal && dataFinal < dataInicial) {
			ScreenService.showMessage(mensagem);
			return false;
		}
		return true;
	};
	 /**
    * Realisa validação dos fiels da widget
    *
    * @param {object, object, object} widget da widget de
    * Documentos Fiscais
    */
    this.validaCampos = function(currentRow, widget, args) {
		if (this.validaData(currentRow)) {
			if(widget.isValid()) {
            	var row = currentRow.REPORT_CODE;
			    General.openReportPopup(widget, this.abreRelatorio, [currentRow, args]);
				//this.abreRelatorio(currentRow, args);
			}
		}
	};
     /**
    * Gera o relatorio em PDF
    *
    * @param {object, object widget da widget de
    * Documentos Fiscais
    */
    this.abreRelatorio = function(currentRow, args) {
    	var relatorio  = currentRow.REPORT_CODE;
    	var camposComDefault = [];
    	var WdgDocumentos = templateManager.container.getWidget("ctb00700_documentos_contabeis");
    	args.row.NRORG = getLocalVar('NRORG');
    	switch (relatorio) {
            case 'CTB23000':
                break;
            case 'CTB21000':
                camposComDefault =  ["NRPAGINA",  'DIARIO', 'ULTPAGINA'];
                this.aplicaDefault(WdgDocumentos, camposComDefault);
                break;
    	}
    	General.openReport('ctb#/relatorios_contabeis', relatorio, args.row);
    }.bind(this);


  /**
    *  Seta Default campo de acordo com a regras para cada relatório
    *
    * @param {object, object, array, int} widget da widget de
    * Documentos Fiscais
    */
    this.aplicaDefault = function(WdgDocumentos, camposComDefault){

        camposComDefault.forEach(function(campoName) {
            var campo = WdgDocumentos.getField(campoName);

            WdgDocumentos.currentRow[campoName] = WdgDocumentos.currentRow[campoName] != "" ? WdgDocumentos.currentRow[campoName] : campo.defaultValue;
        }.bind(this));
    };


     /**
    * Configurações do realtorio por tipo de apuiração
    *
    * @param {object, object, object}, object} widget da widget de
    * Documentos Fiscais
    */
    this.layoutRelatorio = function(relatorio, widget, campos, camposNaoObrigat = [], camposReadOnly = []) {
        switch (relatorio) {
            case 'creditos_MG':
                this.limpaTela(widget);
                camposReadOnly = ["SGIMPOSTONFE", "NRSEQUMAPAPU", "CDINSCESTA"];
                campos = ["NMEMPRESA","DTINIPERIODO","DTFIMPERIODO","NRSEQUMAPAPU", "CDINSCESTA", "SGIMPOSTONFE"];
                this.setaCampos(campos, widget, camposNaoObrigat, camposReadOnly);

                widget.currentRow.IDORGARRECADNFE = "E";
                widget.currentRow.IDFORMAPURNFE = "E";
                widget.currentRow.CDIMPOSTONFE = '00';
                widget.getField('SGIMPOSTONFE').setValue('ICMS');
                if(widget.floatingControl.xlsAction){
                    widget.floatingControl.xlsAction.dataSourceName = "fis_relatorios#/crud/creditos_MG";
                    widget.floatingControl.pdfAction.dataSourceName = "fis_relatorios#/crud/creditos_MG";
                }
                widget.dataSource.name = "fis_relatorios#/crud/creditos_MG";
                break;

            default:
                this.limpaTela(widget);
        }
    };

    //Troca a data final com base na inicial, dependendo de alguma regra do relatorio
    this.DTINIPERIODOOnChange = function(widget) {
        var relatorio  = widget.currentRow.REPORT_CODE;
        var DTFIMPERIODOField = widget.getField("DTFIMPERIODO");
        var DTINIPERIODOField = widget.getField("DTINIPERIODO");
        if(DTINIPERIODOField.value()){
            /*switch (relatorio) {
                case 'CTB23001':
                    let umAnoDepois = moment(DTINIPERIODOField.value(), "DD/MM/YYYY");
                    umAnoDepois = umAnoDepois.add(1, 'y');
                    DTFIMPERIODOField.setValue(umAnoDepois.format("DD/MM/YYYY"));
                    break;
                default:
            }*/
        }else{
            DTFIMPERIODOField.setValue(null);
        }
    };

        //Troca a data final com base na inicial, dependendo de alguma regra do relatorio
    this.incestaOnChange = function(widget) {
        var CDINSCESTAField = widget.getField("CDINSCESTA");
        var NRSEQUMAPAPUField = widget.getField("NRSEQUMAPAPU");

        if(CDINSCESTAField.value()){
            NRSEQUMAPAPUField.dataSourceFilter.forEach(function(filtro){
                if(filtro.name == 'CDIMPOSTO'){
                    filtro.value = widget.currentRow.CDIMPOSTONFE;
                }else{
                    filtro.value = widget.currentRow[filtro.name]||'%%';
                }
            });
            NRSEQUMAPAPUField.reload().then(function(mapa){
                mapa = mapa.dataset.mapa_Estadual;
                if(mapa[0]){
                    NRSEQUMAPAPUField.setValue(mapa[0].NRSEQUMAPAPU);
                }else{
                    // traduzir isso
                   ScreenService.showMessage('Mapa não encontrado');
                }
            });
        }else{
            NRSEQUMAPAPUField.setValue(null);
        }
    };

     /**
    * Configurações do filtro
    *
    * @param {object, object, object}, object} widget da widget de
    * Documentos Fiscais
    */
    this.aplicaFiltro = function(widget) {

        switch (widget.appliedFilter.FILTER_ROW.REPORT_CODE) {
            case 'creditos_MG':
                widget.dataSourceFilter = [
                    {
                        "name": "NRSEQUMAPAPU",
                        "operator": "=",
                        "value": widget.appliedFilter.FILTER_ROW.NRSEQUMAPAPU
                    }
                ];
                break;

            default:
                widget.dataSourceFilter = [];
        }
    };


    self.setContctblMask = function() {
       General.callRestEngine("cadCtb#/crud/paramgeral", "FilterData", []).then(function(response) {
            var paramgeral = response.dataset.paramgeral[0];
            localStorageEngine.setLocalVar('CDPICTCCTB', paramgeral.CDPICTCCTB);
       });
    };
}
Configuration(function(ContextRegister)
{
    ContextRegister.register('fis96000_conferencia_fiscal_relatorios_Controller', fis96000_conferencia_fiscal_relatorios_Controller);
});